/* (C) Matthew Kirkwood <matthew@hairy.beasts.org> */

/* Atomic dec: return 1 if counter decremented to negative.
 */
static int __down(int *c)
{
	int r = 0;

	__asm__ __volatile__ (
	"	lock; decl %1\n"
	"	jns 1f\n"
	"	incl %0\n"
	"1:\n"
		: "=r"(r), "=m"(*c) : "0"(r)
	);
	return r;
}

/* Atomic inc: return 1 if counter incremented to <= 0. */
static __inline__ int __up(int *c)
{
	int r = 0;

	__asm__ __volatile__ (
	"	lock; incl %1\n"
	"	jg 1f\n"
	"	incl %0\n"
	"1:\n"
		: "=q"(r), "=m"(*c) : "0"(r)
	);
	return r;
}

/* Commit the write, so it happens before we send the semaphore to
   anyone else */
static __inline__ void __commit(void)
{
	/* Probably overkill, but some non-Intel clones support
           out-of-order stores, according to 2.5.5-pre1's
           linux/include/asm-i386/system.h */
	__asm__ __volatile__ ("lock; addl $0,0(%%esp)": : :"memory");
}
