#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <fcntl.h>
#include <sys/mman.h>
#include "usersem.h"

int main(int argc, char *argv[])
{
	struct usersem *sem;
	int fd, usem_fd;
	void *map;
	unsigned int i;

	if (argc != 4) {
		fprintf(stderr, "Usage: test-dual <file> <offset> <iterations>\n");
		exit(1);
	}
	fd = open(argv[1], O_RDWR);
	if (fd < 0) {
		perror("opening file");
		exit(1);
	}
	map = mmap(NULL, 4096, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0);
	if (map == MAP_FAILED) {
		perror("mmap");
		exit(1);
	}

	usem_fd = usem_open();
	if (usem_fd < 0) {
		perror("usem_open");
		exit(1);
	}
	sem = map + atoi(argv[2]);

	for (i = 0; i < atoi(argv[3]); i++) {
		fprintf(stderr, "%i", getpid());
		usem_down(sem, usem_fd);
		fprintf(stderr, "v\n");
		/* Write pid here */
		*(volatile int *)(sem + 1) = getpid();
		sleep(0);
		if (*(volatile int *)(sem + 1) != getpid())
			printf("ARGH!\n");
		fprintf(stderr, "%i", getpid());
		usem_up(sem, usem_fd);
		fprintf(stderr, "^\n");
		sleep(0);
	}
	usem_close(usem_fd);
	exit(0);
}
	
