/* Fast userspace semaphores. 
 * Based on work by Matthew Kirkwood <matthew@hairy.beasts.org>. */
#include "usersem.h"
#include <stdint.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
/* This must include the futex and futex_region calls */
#include <asm/unistd.h>

#include ARCH_ATOMICS_C

#if 1
#define __NR_futex_region	208
#define __NR_futex		209
#endif

_syscall2(int,futex_region,void *,region,size_t, len);
static _syscall2(int,futex,struct futex *,futex,int, op);

void futex_init(struct futex *futx)
{
	futx->count = 1;
	__commit();
}

/* Down and up operations */
int futex_down(struct futex *futx)
{
	if (__down(&futx->count))
		return futex(futx, -1);
	return 0;
}

int futex_up(struct futex *futx)
{
	if (__up(&futx->count))
		return futex(futx, 1);
	return 0;
}
